//Jeannie Albrecht

import java.io.*;
import java.util.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import org.jdom.xpath.*;

public class GenHash {
    static Document reqdoc;
    HashMap replyStats, grouptonodes, latency_map;
    Vector hashes;
    SAXBuilder builder;
    static String PATH="/home/albrecht/sword/planetlab/";

    public GenHash() {
       	builder=new SAXBuilder();
    }

    public void createHashMap(String datafile, String pingfile, String requestfile) {
	grouptonodes=new HashMap();

	File f2=null, f3=null;
	HashMap latency_map=null, h=null;
	Element child, node=null, next=null, root=null;;
	Iterator itr=null, i3=null, it2=null;
	List result=null;
	int count=0;

	try {		    
	    ObjectInputStream oos = new ObjectInputStream(new FileInputStream(new File(datafile)));
	    this.replyStats=(HashMap) oos.readObject();
	    oos.close();			    
	}   
	catch (Exception e1) {
	    System.out.println("e1: "+e1);
	    System.out.println(this.replyStats);
	}

	try {		    
	    ObjectInputStream oos = new ObjectInputStream(new FileInputStream(new File(pingfile)));
	    this.latency_map=(HashMap) oos.readObject();
	    oos.close();			    
	}   
	catch (Exception e1) {
	    System.out.println("e1: "+e1);
	}
	
	try {		    
	    ObjectInputStream oos = new ObjectInputStream(new FileInputStream(new File(requestfile)));
	    reqdoc=(Document) oos.readObject();
	    oos.close();			    
	}   
	catch (Exception e1) {
	    System.out.println("e1: "+e1);
	}
	
	List l=reqdoc.getRootElement().getChildren("group");
	Iterator groupIterator=l.iterator();
	HashMap hm[]=new HashMap[l.size()];
	String groupnames[] = new String[l.size()];

	for (int i=0; i<l.size(); i++) {
	    hm[i]=new HashMap(); 
	    groupnames[i]="";
	}

	Iterator it=replyStats.keySet().iterator();
	while (it.hasNext()) { 
	    //loop through replyStats (which is data.xml)
	    //HERE IS WHERE I CHECK FOR SINGLE NODE ATTRIBUTES
	    String n=(String)it.next();
	    h=(HashMap)replyStats.get(n);

	    //loop through group requests
	    groupIterator=l.iterator();
	    while(groupIterator.hasNext()) {
		List metrics=((Element)groupIterator.next()).getChildren();
		Iterator metIt=metrics.iterator();
		double cost=0;
		boolean sat=true;

		while (metIt.hasNext()) {
		    Element met=(Element)metIt.next();		    

		    if(met.getName().equals("name")) {
			groupnames[count]=met.getTextTrim();
		    }

		    if(h.get(met.getName())!=null) {
			String reqval=met.getTextTrim();

			if (reqval.length()!=0) { 
			    //double attribute
			    StringTokenizer st=new StringTokenizer(reqval, ",");
			    double absmin=Double.valueOf(st.nextToken()).doubleValue();
			    double idealmin=Double.valueOf(st.nextToken()).doubleValue();
			    double idealmax=Double.valueOf(st.nextToken()).doubleValue(); 
			    double absmax=Double.valueOf(st.nextToken()).doubleValue();
			    double weight=Double.valueOf(st.nextToken()).doubleValue();

			    String svsite = (String)h.get(met.getName());
			    double val=Double.valueOf(svsite).doubleValue();
			    double denom=0;

			    //			    System.out.println(n+" "+met.getName()+" "+val);
			    if(val>absmin && val<absmax) {
				if(val<idealmin) {				    
				    denom=idealmin-absmin;
				    if(denom!=0)
					cost+=((idealmin-val)/denom)*weight;
				}
				else  if(val>idealmax) {
				    denom=absmax-idealmax;
				    if(denom!=0)
					cost+=((val-idealmax)/denom)*weight;
				}
			    }
			    else {
				sat=false;
			    }			    
			}
			else { 
			    //String attribute
			    List values = ((Element)met).getChildren();
			    Iterator valIt = values.iterator();
			    
			    while(valIt.hasNext()) {
				Element val = (Element)valIt.next();
				if(h.get(met.getName())!=null) {
				    reqval=val.getTextTrim();

				    if (reqval.length()!=0) {
					StringTokenizer st=new StringTokenizer(reqval, ",");
					String valrequested = st.nextToken();
					double weight = Double.valueOf(st.nextToken()).doubleValue();

					String svsite = (String)h.get(met.getName());
					if(!met.getName().equals("hostname") && !met.getName().equals("ip")) {
					    if (svsite.equals(valrequested)) {
						cost+=weight;
					    }
					    else {
						sat=false;
					    }
					}
					else {
					    //hostname and ip
					    if(met.getName().equals("hostname") && !svsite.equals(valrequested)) {
						cost+=weight;
					    }
					    else if(met.getName().equals("ip") && !svsite.equals(valrequested)) {
						cost+=weight;
					    }
					    else if(met.getName().equals("hostname") && svsite.equals(valrequested)) {
						cost+=0;
					    }
					    else if(met.getName().equals("ip") && svsite.equals(valrequested)) {
						cost+=0;
					    }
					}
				    }
				}
			    }
			}
		    }
		    else if (!met.getName().equals("name") && !met.getName().equals("numhosts") 
			     && !met.getName().equals("num_machines") && !met.getName().equals("latency")) {
			//innocent until proven guilty--if no value is specified, we assume the requirement is met?
			//			sat=true;
			sat=false;
		    }
		}
		if(sat) {
		    //if(count==0)
			//System.out.println(n+" "+h.get("load_five")+" "+cost+" "+h.get("site_str"));
		    hm[count].put(n,new Double(cost));
		}
		count++;
	    }

	    count=0;
	}
	
	for(int i=0; i<l.size(); i++) {
	    grouptonodes.put(groupnames[i], hm[i]);
	}
	
    }
    
    public HashMap getGroupToNodes() {
	return grouptonodes;
    }

    public HashMap getLatencyMap() {
	return latency_map;
    }

    public HashMap getReplyStats() {
	return replyStats;
    }
    
    public static void writeXML(String outfilename, Document doc) {	
	XMLOutputter outputter = new XMLOutputter("   ", true);
	File outfile=null;

	try {
	    //output XML file
	    outfile=new File(outfilename);
	    if(outfile.exists()) {
		if(!outfile.delete()) {
		    System.err.println("Error deleting "+outfilename);
		    System.exit(1);
		}
	    }

	    FileWriter writer = new FileWriter(outfilename); 
	    outputter.output(doc, writer);
	    writer.close();    
	} catch (Exception e) {
	    System.err.println(e);
	}	
    }

    public static void main (String args[]) {
	if(args.length!=7) {
	    System.out.println("Usage:  java GenHash dataDoc pingDoc reqDoc DEBUG DEBUG2 1/2 numgroups");
	    System.exit(1);
	}
	GenHash g=new GenHash();
	String requestfile = args[2];
	SAXBuilder builder2 = new SAXBuilder();
	int numgroups=Integer.parseInt(args[6]);

	if(requestfile.endsWith(".xml")) {
	    try {
		Document doc = builder2.build(new File(args[2]));
		ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(new File (PATH+"reqDoc")));
		oos.writeObject(doc);
		oos.close();
		//System.out.println("done creating reqDoc");
		requestfile=PATH+"reqDoc";
		//writeXML("request.xml", doc);
	    }	
	    catch (Exception ee) {
		System.out.println("ee: "+ee);
	    }
	}
	 
	g.createHashMap(args[0], args[1], requestfile);

	long starttime=System.currentTimeMillis();
	//System.out.println("Starting at "+starttime);

	FindHosts fh=new FindHosts(reqdoc, starttime);
	if(args[3].equals("true")) 
	    fh.setDebug(true);

	if(args[4].equals("true")) 
	    fh.setDebug2(true);	

	Vector nodes=fh.getMasterList(g.getReplyStats(), g.getGroupToNodes(), g.getLatencyMap());
	int searchtime=0;
	if(reqdoc.getRootElement().getChildTextTrim("search_time")!=null) 
	    searchtime=(int)(Double.valueOf(reqdoc.getRootElement().getChildTextTrim("search_time")).doubleValue());	    	
	else searchtime=99999999;
	Vector groups=null;
	if(!args[5].equals("2"))
	    groups=fh.createGroups(nodes, (long)searchtime, numgroups);
	else {
	    groups = fh.createGroups(nodes, (long)searchtime, numgroups);
	}
	
	HashMap replies = g.getReplyStats();

	String result="";
	//print results
	int i=0;
	
	//System.out.println("Total searches "+fh.matchcounter);
	System.out.println("Total elapsed time:  "+((System.currentTimeMillis()-starttime)/1000.0)+" seconds");
	System.out.println(fh.getResult());

	System.out.println("Groups\n-------------------");
	if(groups.size()==0) {
	    System.out.println("No groups were found that meet the criteria!");
	}
	else {
	    HashMap grouphash=fh.getMasterGrouphash();
	    for(i=0; i<numgroups; i++) {
		for (int j=0; j<((Vector)groups.elementAt(i)).size(); j++) {
		    Group gg = (Group) grouphash.get((Integer)(((Vector)groups.elementAt(i)).elementAt(j)));
		    System.out.println("  Name: "+gg.getName()+"-"+gg.getID());
		    System.out.println("  Max Latency: "+gg.getMaxLatency()+" ms"); 
		    System.out.println("  Min Latency: "+gg.getMinLatency()+" ms"); 
		    System.out.println("  Overall Group Cost: "+gg.getCost());
		    System.out.println("  Group Size:  "+gg.getMachines());
		    
		    for (int k=0; k<gg.getList().size(); k++) {
			String name = (String)((gg.getList()).elementAt(k));
			HashMap h = (HashMap)replies.get(name);		   
			System.out.println("    "+name+" ["+h.get("hostname")+"]");
			//+"-"+h.get("site_str")+"]");
		    }
		    System.out.println();
		}
		System.out.println("--------------------------");
	    }
	}
	result+=fh.getTotalCost();
	System.out.println("Lowest match cost: "+result);
	//	System.out.println("Ending at "+System.currentTimeMillis());
    }
}
    
// 	result+="\n\nMaster node list\n-------------------\n";
// 	for (i=0; i<nodes.size(); i++) {
// 	    Vector vec=(Vector)nodes.elementAt(i);
// 	    result+="Group"+(i+1)+" candidate nodes:\n";
// 	    for (int j=0; j<vec.size();j++) {
// 		result+="  "+((Node)vec.elementAt(j)).getName()+"\n";
// 	    }	   
// 	    result+="Total nodes in group: "+vec.size()+"\n"; 
// 	}
// 	System.out.println(result);
// 	result="";

// 	    result+=fh.getResult()+"\n****************************\n\n";	

// 	    int printlimit=9999999;

// 	    if(args.length==4) {
// 		printlimit=Integer.parseInt(args[3]);
// 	    }

	   //  HashMap grouphash=fh.getMasterGrouphash();
// 	    for (int ii=0; ii<grouphash.size(); ii++) {
// 		Vector v=(Vector)grouphash.get("Group"+(ii+1));  
// 		result+="\nGroup"+(ii+1)+"\n";
// 		if(printlimit>v.size()) {
// 		    printlimit=v.size();
// 		}
// 		for (int j=0; j<printlimit; j++) {
// 		    result+=(j+1)+") Cost:  "+((Group)v.elementAt(j)).getCost()+"\n";
// 		    for (int jj=0; jj<((Group)v.elementAt(j)).getList().size(); jj++) {
// 			result+=(((Group)v.elementAt(j)).getList().elementAt(jj))+"\n";
// 		    }
// 		    result+="\n";
// 		    System.out.println(result);
// 		    result="";
// 		}
// 	    }
