//Jeannie Albrecht

import java.io.*;
import java.text.*;
import java.util.*;

import org.jdom.xpath.*;
import org.jdom.*;
import org.jdom.output.*;
import org.jdom.input.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;
import javax.xml.transform.dom.*;

public class ParsePing{
    Document doc=null;
    static boolean writeXML = false;
    String PATH = "/home/albrecht/sword/planetlab/";

    public ParsePing() {

    }

    public void parseData(String filename, boolean w) {
	writeXML = w;
	System.out.println("Parsing "+filename+"...");
	
	String ip_addr="";
	String date="";
	String next_line="";
	String source="";
	String dest="";
	String next_meas="";

	StringTokenizer st=null;
	StringTokenizer st2=null;
	StringTokenizer st3=null;
	StringTokenizer st4=null;

	int num_pings=0;
	double avg_ping=0.0;

	File f=null;
	FileInputStream fis=null;
	BufferedReader file=null;	

	Element root=null;
	HashMap latencies=new HashMap();

	try {
	    //input file (current.app)
	    f = new File(filename);
	    fis = new FileInputStream(f);
	    file = new BufferedReader(new InputStreamReader(fis));
	    
	    if (writeXML) {
		root=new Element("root");
		doc = new Document(root);
	    }

	    date=file.readLine();
	    num_pings=Integer.valueOf(file.readLine()).intValue();
	    ip_addr=file.readLine();

	    if (writeXML) {
		root.setAttribute("date",date);
	    }

	    st = new StringTokenizer(ip_addr, " ");	    	    
	    next_line=file.readLine();
	    source=st.nextToken();

	    while(next_line!=null && st.hasMoreTokens()) {
		st2 = new StringTokenizer(ip_addr, " ");
		st3 = new StringTokenizer(next_line, " ");
		
		if(!next_line.startsWith("***")) {
		    while(st2.hasMoreTokens()) {
			dest=st2.nextToken().trim();					
			next_meas=st3.nextToken().trim();
			
			if(!next_meas.startsWith("***") && !dest.equals(source)) {
			    st4 = new StringTokenizer(next_meas, "/");
			    st4.nextToken(); //min ping		
			    avg_ping=Double.valueOf(st4.nextToken()).doubleValue(); //avg ping
			    
			    if (writeXML) {
				Element node = new Element("node");
				root.addContent(node);
				node.addContent(new Element("source").addContent(source));
				node.addContent(new Element("dest").addContent(dest));
				node.addContent(new Element("latency").addContent(String.valueOf(avg_ping)));
						    }
			    
			    latencies.put("s:"+source+"d:"+dest, new Double(avg_ping));
			}
		    }		    
		}
		latencies.put("s:"+source+"d:"+source, new Double(0));
		next_line=file.readLine();
		source=st.nextToken();
	    }
	    file.close();
	    fis.close();
	    System.out.println("file done.");
	}
	catch (Exception e) {
	    System.out.println(e);    
	}
	finally { 
	    st=null;
	    st2=null;
	    st3=null;
	    st4=null;
	    
	    f=null;
	    fis=null;
	    file=null;
	    
	}
			
	try {
	    ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(new File (PATH+"pingDoc")));
	    oos.writeObject(latencies);
	    oos.close();
	}	
	catch (Exception ee) {
	    System.out.println("ee: "+ee);
	}	
	
	if (writeXML) 
	    writeXMLDoc("ping.xml", doc);
    }

    public void writeXMLDoc(String outfilename, Document doc) {	
	XMLOutputter outputter = new XMLOutputter("   ", true);
	File outfile=null;

	try {
	    //output XML file
	    outfile=new File(outfilename);
	    if(outfile.exists()) {
		if(!outfile.delete()) {
		    System.err.println("Error deleting ping.xml");
		    System.exit(1);
		}
	    }

	    FileWriter writer = new FileWriter(outfilename); 
	    outputter.output(doc, writer);
	    writer.close();    
	} catch (Exception e) {
	    System.err.println(e);
	}	
    }

    public static void main (String args[]) {
	String filename="current.app";
	if(args.length>0) 
	   filename=args[0];
	ParsePing pp = new ParsePing();
	pp.parseData(filename, true);		
    }
}



