import java.io.*;
import java.text.*;
import java.util.*;
import org.jdom.*;
import org.jdom.output.*;
import org.jdom.input.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;
import javax.xml.transform.dom.*;

public class createDataXML{
    SAXBuilder builder;
    static String PATH="/home/albrecht/sword/planetlab/";
    
    public createDataXML() {
	builder=new SAXBuilder();
    }

    public void writeXML(String datafile) {
	Document doc=null;
	Document olddoc=null;
	Element root=null;
	File f=null;
	File total=null;

	f = new File(datafile);        

	//Need to read in the current XML file	
	if (!f.exists()) {
	    System.out.println("File "+datafile+" does not exist");
	    System.exit(1);
	}

	try {	    
	    olddoc = builder.build(f);
	} catch(Exception e) {
	    System.out.println("problem here");
	    e.printStackTrace();
	}

	root = new Element("root");
	doc = new Document(root);	    

	HashMap replyStats=new HashMap();
	List hosts=olddoc.getRootElement().getChild("GRID").getChildren("CLUSTER");
	Iterator it=hosts.iterator();
	
	while (it.hasNext()) {
	    Element nextone=(Element)it.next();
	    String site=(nextone.getAttribute("NAME")).getValue();
	    
	    double site_value=0;
	    for(int i=0; i<site.length(); i++) {
		site_value+=(int)site.charAt(i);
	    }
	    
	    List children=nextone.getChildren("HOST");
	    Iterator it2=children.iterator();

	    while(it2.hasNext()) {
		Element host = (Element)it2.next();
		List metrics=host.getChildren("METRIC");
		Iterator it3=metrics.iterator();
		String hostname=(host.getAttribute("NAME")).getValue();
		String ip=(host.getAttribute("IP")).getValue();

		HashMap h=new HashMap();
		Element node=new Element("node");
		root.addContent(node);
		node.addContent(new Element("site").addContent(site));
		node.addContent(new Element("ip").addContent(ip));
		h.put("ip", ip);
		node.addContent(new Element("hostname").addContent(hostname));
		h.put("hostname", hostname);

		while (it3.hasNext()) {
		    Element metric=(Element) it3.next();
		    node.addContent(new Element((metric.getAttribute("NAME")).getValue()).addContent((metric.getAttribute("VAL")).getValue()));
		    h.put(metric.getAttribute("NAME").getValue(), metric.getAttribute("VAL").getValue());
		}
		h.put("site",new Double(site_value));
		h.put("site_str", site);
		replyStats.put(ip, h);
	    }
	}

	try {
	    ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(new File (PATH+"dataDoc2")));
	    writeXML("data2.xml", doc);
	    System.out.println(replyStats);
	    oos.writeObject(replyStats);
	    oos.close();
	    System.out.println("done");
	}	
	catch (Exception ee) {
	    System.out.println("ee: "+ee);
	}
    }    
    
    public void writeXML(String outfilename, Document doc) {	
	XMLOutputter outputter = new XMLOutputter("   ", true);
	File outfile=null;

	try {
	    //output XML file
	    outfile=new File(outfilename);
	    if(outfile.exists()) {
		if(!outfile.delete()) {
		    System.err.println("Error deleting "+outfilename);
		    System.exit(1);
		}
	    }

	    FileWriter writer = new FileWriter(outfilename); 
	    outputter.output(doc, writer);
	    writer.close();    
	} catch (Exception e) {
	    System.err.println(e);
	}	
    }

    public static void main (String args[]) {
	createDataXML s = new createDataXML();
	s.writeXML(args[0]);
    }
    
}
